import grok
from zc.sourcefactory.basic import BasicSourceFactory

class ManageUniversity(grok.Permission):
    grok.name('waeup.manageUniversity')

class ManageUsers(grok.Permission):
    grok.name('waeup.manageUsers')
    
class FacultyRead(grok.Permission):
    grok.name('waeup.facultyread')

class PortalUser(grok.Role):
    grok.name('waeup.PortalUser')
    grok.permissions('waeup.facultyread')

class PortalManager(grok.Role):
    grok.name('waeup.PortalManager')
    grok.permissions('waeup.manageUniversity', 'waeup.manageUsers')

def getRoles():
    app = grok.getSite()
    app = None
    manager = None
    if app is not None:
        from zope.securitypolicy.interfaces import IRolePermissionManager
        manager = IRolePermissionManager(app, None)
    else:
        from zope.securitypolicy.rolepermission import (
            rolePermissionManager as manager)
    role_permission_map =  manager.getRolesAndPermissions()
    result = dict()
    for item in role_permission_map:
        if not item[1].startswith('waeup.'):
            # Ignore non-WAeUP roles...
            continue
        result[item[1]] = True
    return sorted(result.keys())

class RoleSource(BasicSourceFactory):
    def getValues(self):
        return getRoles()
    def getTitle(self, value):
        if isinstance(value, basestring):
            return value.split('.', 2)[1]
